.386
.model flat,stdcall
option casemap:none

include Snake.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,SIZEOF WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,OFFSET WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,IDR_MENU
	mov		wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke LoadAccelerators,hInst,IDR_ACCEL
	mov		hAccel,eax
	invoke CreateDialogParam,hInstance,IDD_SNAKE,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateAccelerator,hWnd,hAccel,addr msg
		.if !eax
			invoke TranslateMessage,addr msg
			invoke DispatchMessage,addr msg
		.endif
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

Random proc range:DWORD

	mov eax, rseed
	mov ecx, 23
	mul ecx
	add eax, 7
	and eax, 0FFFFFFFFh
	ror eax, 1
	xor eax, rseed
	mov rseed, eax
	mov ecx, range
	xor edx, edx
	div ecx
	mov eax, edx
	ret

Random endp

Score proc
	LOCAL	buffer[32]:BYTE

	invoke lstrcpy,addr buffer,offset szScore
	lea		edx,buffer
	add		edx,sizeof szScore-1
	invoke wsprintfA,edx,offset fmtStr,len
	invoke MessageBox,hWnd,addr buffer,offset AppName,MB_OK
	ret

Score endp

SetupGame proc hWin:HWND

	.if maze
		push	ebx
		mov		ebx,offset board
		mov		ecx,32*32
		.while ecx
			mov		al,[ebx]
			.if al!=15
				mov		byte ptr [ebx],0
			.endif
			inc		ebx
			dec		ecx
		.endw
		pop		ebx
	.else
		invoke RtlZeroMemory,offset board,sizeof board
	.endif
	mov		board[0],1
	mov		dirx,1
	mov		diry,0
	mov		headx,0
	mov		heady,0
	mov		tailx,0
	mov		taily,0
	mov		len,1
	mov		grow,4
	mov		shrink,0
	mov		halt,TRUE
	invoke InvalidateRect,hWin,NULL,TRUE
	ret

SetupGame endp

SetupMaze proc hWin:HWND

	.if maze
		xor		edx,edx
		.while edx<32*32
			push	edx
			invoke Random,256
			pop		edx
			.if eax>=1 && eax<=4
				.while eax
					.if edx>=8 && edx<32*32
						mov		board[edx],15
						inc		edx
					.endif
					dec		eax
				.endw
			.endif
			inc		edx
		.endw
	.endif
	invoke InvalidateRect,hWin,NULL,TRUE
	ret

SetupMaze endp

PaintBoard proc hDC:HDC
	LOCAL	nImg:BYTE

	xor		edx,edx
	.while edx<32
		xor		ecx,ecx
		.while ecx<32
			push	ecx
			push	edx
			mov		eax,edx
			shl		eax,5
			add		eax,ecx
			add		eax,offset board
			movzx	eax,byte ptr [eax]
			shl		ecx,3
			shl		edx,3
			invoke ImageList_Draw,hIml,eax,hDC,ecx,edx,ILD_NORMAL
			pop		edx
			pop		ecx
			inc		ecx
		.endw
		inc		edx
	.endw
	ret

PaintBoard endp

BoardProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	ps:PAINTSTRUCT

	.if uMsg==WM_PAINT
		invoke BeginPaint,hWin,addr ps
		invoke PaintBoard,ps.hdc
		invoke EndPaint,hWin,addr ps
		xor		eax,eax
		ret
	.endif
	invoke CallWindowProc,OldBoardProc,hWin,uMsg,wParam,lParam
	ret

BoardProc endp

TimerProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	x:DWORD
	LOCAL	y:DWORD

	.if !halt
		;Set head to the direction
		mov		edx,heady
		shl		edx,5
		add		edx,headx
		add		edx,offset board
		.if dirx==1
			mov		al,1
		.elseif dirx==-1
			mov		al,3
		.elseif diry==1
			mov		al,2
		.else
			mov		al,4
		.endif
		mov		[edx],al
		mov		eax,dirx
		add		headx,eax
		mov		eax,diry
		add		heady,eax
		.if headx<32 && heady<32
			;Add new head
			mov		edx,heady
			shl		edx,5
			add		edx,headx
			add		edx,offset board
			movzx	eax,byte ptr [edx]
			.if !eax || (eax>=5 && eax<=14)
				.if eax>=5 && eax<=13
					;Ate some fruit
					sub		eax,4
					add		grow,eax
					mov 	eax, point
					add 	len,eax
				.elseif eax==14
					;Ate some rotten fruit
					mov		eax,len
					shr		eax,1
					mov		shrink,eax
				.endif
				.if dirx==1
					mov		al,1
				.elseif dirx==-1
					mov		al,3
				.elseif diry==1
					mov		al,2
				.else
					mov		al,4
				.endif
				mov		[edx],al
				;Tail
				.if grow
					;Let it grow
					dec		grow
					inc		len
				.else
					call	RemoveTail
				.endif
				.if shrink
					;Let it shrink by one
					call	RemoveTail
					dec		len
					dec		shrink
				.endif
				;Show some food
				invoke Random,64
				.if eax<32
					mov		x,eax
					invoke Random,32
					.if eax<32
						mov		y,eax
						invoke Random,32
						.if eax>=5 && eax<=14
							.if !rotten && eax==14
								dec		eax
							.endif
							mov		cl,al
							mov		edx,y
							shl		edx,5
							add		edx,x
							add		edx,offset board
							mov		al,[edx]
							.if !al
								mov		[edx],cl
							.endif
						.endif
					.endif
				.endif
			.else
				;The snake bite itself or hit maze
				mov		halt,TRUE
			.endif
		.else
			;Outside boarder
			mov		halt,TRUE
		.endif
		invoke InvalidateRect,hBoard,NULL,TRUE
		.if halt
			invoke Score
		.endif
	.else
		inc		rseed
	.endif
	ret

RemoveTail:
	;Remove one from tail
	mov		edx,taily
	shl		edx,5
	add		edx,tailx
	add		edx,offset board
	mov		al,[edx]
	.if al==1
		;Right
		inc		tailx
	.elseif al==2
		;Down
		inc		taily
	.elseif al==3
		;Left
		dec		tailx
	.elseif al==4
		;Up
		dec		taily
	.endif
	mov		byte ptr [edx],0
	retn

TimerProc endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	hBmp:DWORD

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
		invoke GetMenu,hWnd
		mov 	hMenu,Eax
		mov 	point, 0
	    invoke ImageList_Create,8,8,ILC_COLOR4,16,16
	    mov     hIml,eax
	    invoke LoadBitmap,hInstance,IDB_SNAKE
	    mov     hBmp,eax
	    invoke ImageList_Add,hIml,hBmp,NULL
	    invoke DeleteObject,hBmp
		invoke GetDlgItem,hWin,IDC_BOARD
		mov		hBoard,eax
		invoke SetWindowLong,hBoard,GWL_WNDPROC,offset BoardProc
		mov		OldBoardProc,eax
		invoke SetupGame,hBoard
		invoke SetTimer,hWin,200,200,offset TimerProc
	.elseif eax==WM_KEYDOWN
		mov		eax,lParam
		shr		eax,16
		and		eax,7FFFh
		.if eax==014Dh
			;Right
			mov		dirx,1
			mov		diry,0
		.elseif eax==014Bh
			;Left
			mov		dirx,-1
			mov		diry,0
		.elseif eax==0150h
			;Down
			mov		dirx,0
			mov		diry,1
		.elseif eax==0148h
			;Up
			mov		dirx,0
			mov		diry,-1
		.endif
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDM_FILE_EXIT
			invoke SendMessage,hWin,WM_CLOSE,0,0
        .elseif eax==IDM_PAUSE
			cmp ipause,0
			jnz @F
			invoke CheckMenuItem,hMenu,IDM_PAUSE,MF_CHECKED
			
			mov halt,TRUE
			invoke SetWindowText,hWin,addr pauseTitle
			or ipause,1
		    xor eax,eax
		    ret
			@@:
			and ipause,0
			invoke CheckMenuItem,hMenu,IDM_PAUSE,MF_UNCHECKED
			mov halt,FALSE
			invoke SetWindowText,hWin,addr AppName
		.elseif eax==IDM_NEW_GAME
			invoke SetupGame,hBoard
			mov		halt,FALSE
			mov     ipause,0
		.elseif eax==IDM_S_1
			Mov 	point, 0
			invoke CheckMenuItem,hMenu,IDM_S_1,MF_CHECKED
			invoke CheckMenuItem,hMenu,IDM_S_2,MF_UNCHECKED
			invoke CheckMenuItem,hMenu,IDM_S_3,MF_UNCHECKED
			invoke KillTimer,hWin,200
			invoke SetTimer,hWin,200,200,offset TimerProc
		.elseif eax==IDM_S_2
			Mov 	point, 1
			invoke CheckMenuItem,hMenu,IDM_S_1,MF_UNCHECKED
			invoke CheckMenuItem,hMenu,IDM_S_2,MF_CHECKED
			invoke CheckMenuItem,hMenu,IDM_S_3,MF_UNCHECKED
			invoke KillTimer,hWin,200
			invoke SetTimer,hWin,200,135,offset TimerProc
		.elseif eax==IDM_S_3
			Mov 	point, 2
			invoke CheckMenuItem,hMenu,IDM_S_1,MF_UNCHECKED
			invoke CheckMenuItem,hMenu,IDM_S_2,MF_UNCHECKED
			invoke CheckMenuItem,hMenu,IDM_S_3,MF_CHECKED
			invoke KillTimer,hWin,200
			invoke SetTimer,hWin,200,67,offset TimerProc
		.elseif eax==IDM_ROTTEN
			xor		rotten,1
			.if rotten
				invoke CheckMenuItem,hMenu,IDM_ROTTEN,MF_CHECKED
			.else
				invoke CheckMenuItem,hMenu,IDM_ROTTEN,MF_UNCHECKED
			.endif
		.elseif eax==IDM_MAZE
			xor		maze,1
			.if maze
				invoke CheckMenuItem,hMenu,IDM_MAZE,MF_CHECKED
			.else
				invoke CheckMenuItem,hMenu,IDM_MAZE,MF_UNCHECKED
			.endif
			invoke SetupGame,hBoard
			invoke SetupMaze,hBoard
		.elseif eax==IDM_HELP_ABOUT
			invoke ShellAbout,hWin,addr AppName,addr AboutMsg,NULL
		.endif

	.elseif eax==WM_CLOSE
		invoke KillTimer,hWin,200
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke ImageList_Destroy,hIml
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	
	
	xor    eax,eax
	ret

WndProc endp

end start
