.386
.model flat,stdcall
option casemap:none

include Volcano.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,SIZEOF WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,OFFSET WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	m2m		wc.hInstance,hInst
	mov		wc.hbrBackground,NULL
	mov		wc.lpszMenuName,IDR_MENU
	mov		wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke LoadAccelerators,hInst,IDR_ACCEL
	mov		hAccel,eax
	invoke CreateDialogParam,hInstance,IDD_VOLCANO,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
		.BREAK .if !eax
		invoke TranslateAccelerator,hWnd,hAccel,addr msg
		.if !eax
			invoke TranslateMessage,addr msg
			invoke DispatchMessage,addr msg
		.endif
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

Random proc uses edx,range:DWORD

	mov eax, 23
	mul rseed
	add eax, 7
	ror eax, 1
	xor eax, rseed
	mov rseed, eax
	xor edx, edx
	div range
	mov eax, edx
	ret

Random endp

PaintBoard proc uses ebx esi edi,hWin:HWND,hDC:HDC
	LOCAL	mDC:HDC
	LOCAL	hBmp:DWORD
	LOCAL	hOld:DWORD
	LOCAL	rect:RECT
	LOCAL	buffer[32]:BYTE
	LOCAL	xmax:DWORD

	mov		rect.left,0
	mov		rect.top,0
	mov		rect.right,256
	mov		rect.bottom,256
	invoke CreateCompatibleDC,hDC
	mov		mDC,eax
	invoke CreateCompatibleBitmap,hDC,256,256
	mov		hBmp,eax
	invoke SelectObject,mDC,hBmp
	mov		hOld,eax
	.if points >= points_LIGHTNING
		; Lighning
		invoke Random, lightning_MAX * lightning_ODDS
		.if eax < lightning_MAX
			mov		clightning,eax
		.endif
	.endif
	.if clightning
		dec		clightning
		invoke GetStockObject,GRAY_BRUSH
	.else
		invoke GetStockObject,BLACK_BRUSH
	.endif
	invoke FillRect,mDC,addr rect,eax
	invoke ImageList_Draw,hIml,image_GUN,mDC,gunx,board_HEIGHT-gun_HEIGHT,ILD_NORMAL
	.if !halt
		dec		cvolcano
		.if !cvolcano
			mov		cvolcano,volcano_SPEED
			mov		esi,offset volcanos
			ASSUME	esi:PTR VOLCANO
			xor		ecx,ecx
			.while ecx < MAX_VOLCANOS
				push	ecx
				mov		xmax,0
				call	MoveVolcano
				.if [esi].xmovs
					mov		eax,[esi].xmovs
					neg		eax
					mov		[esi].xmov,eax
					.if eax > 80000000h
						mov		[esi].state, volcano_SPIN1a
					.else
						mov		[esi].state, volcano_SPIN2a
					.endif
					mov		[esi].xmovs,0
					mov		[esi].ymov,0
				.elseif xmax
					.if [esi].y < board_HEIGHT - volcano_HEIGHT - 4 ;!
						mov		[esi].ymov, volcano_HEIGHT
					.else
						mov		halt,TRUE
						mov		lptext,offset szGameOver
						mov		goy,1250 ;!
					.endif
					m2m		[esi].xmovs,[esi].xmov
					mov		[esi].xmov,0
				.endif
				pop		ecx
				add		esi,SIZEOF VOLCANO
				inc		ecx
			.endw
			call	DropVolcano
			ASSUME	esi:NOTHING
		.endif
	.endif
	mov		esi,offset volcanos
	xor		ecx,ecx
	.while ecx < MAX_VOLCANOS
		push	ecx
		call	DrawVolkano
		pop		ecx
		inc		ecx
	.endw
	.if !halt
		mov		esi,offset shots
		i = 0
		WHILE i NE MAX_SHOTS
			call	MoveShot
			i = i + 1
		ENDM
	.endif
	invoke wsprintfA,addr buffer,offset fmtStr,points
	invoke SetBkMode,mDC,TRANSPARENT
	invoke SetTextColor,mDC,color_SCORE
	invoke DrawText,mDC,addr buffer,-1,addr rect,0
	mov		esi,nguns
	mov		ebx,board_WIDTH - gun_WIDTH
	.while esi
		invoke ImageList_Draw,hIml,0,mDC,ebx,0,ILD_NORMAL
		sub		ebx,gun_WIDTH + 1
		dec		esi
	.endw
	mov		eax,goy
	.if eax
		sub		eax,1000
		mov		rect.top,eax
		mov		rect.left,20
		mov		ebx,lptext
		mov		al,[ebx]
		.while al
			invoke DrawText,mDC,ebx,-1,addr rect, 0 ; DT_CENTER
			add		rect.top,20
			invoke lstrlen,ebx
			inc		eax
			add		ebx,eax
			mov		al,[ebx]
		.endw
		dec		goy
	.endif
	invoke GetClientRect,hWin,addr rect
;	invoke BitBlt,hDC,0,0,rect.right,rect.bottom,mDC,0,0,SRCCOPY
	invoke StretchBlt,hDC,0,0,rect.right,rect.bottom,mDC,0,0,256,256,SRCCOPY
	invoke SelectObject,mDC,hOld
	invoke DeleteDC,mDC
	invoke DeleteObject,hBmp
	inc		loopcount
	.if !ndrop && !nvolcanos
		.if points >= 9000
			mov		ndrop,20
		.elseif points >= 7500
			mov		ndrop,15
		.else
			mov		ndrop,10
		.endif
	.endif
	ret

DrawVolkano:
	ASSUME	esi:PTR VOLCANO
	.if [esi].state
		invoke ImageList_Draw,hIml,[esi].state,mDC,[esi].x,[esi].y,ILD_NORMAL
		mov		eax,loopcount
		and		eax,3 ;! volcano_ANIMATE
		.if !eax
			mov		eax,[esi].state
			mov		eax,[volcano_FSM + eax*4]
			mov		[esi].state,eax
		.endif
	.endif
	add		esi,SIZEOF VOLCANO
	ASSUME	esi:NOTHING
	retn

MoveVolcano:
	ASSUME	esi:PTR VOLCANO
	mov		eax,[esi].state
	.if eax>=1 && eax<=4
		mov		eax,[esi].x
		add		eax,6
		add		eax,[esi].xmov
		mov		ebx,[esi].y
		add		ebx,6
		add		ebx,[esi].ymov
		xor		ecx,ecx
		mov		edi,offset volcanos
		ASSUME	edi:PTR VOLCANO
		.while ecx < MAX_VOLCANOS
			.if esi!=edi
				push	ecx
				mov		ecx,[edi].x
				lea		edx,[ecx + volcano_WIDTH]
				.if eax>=ecx && eax<=edx
					mov		ecx,[edi].y
					lea		edx,[ecx + volcano_HEIGHT]
					.if ebx>=ecx && ebx<=edx
						.if [edi].state
							xor		eax,eax
							pop		ecx
							.break
						.endif
					.endif
				.endif
				pop		ecx
			.endif
			add		edi,SIZEOF VOLCANO
			inc		ecx
		.endw
		ASSUME	edi:NOTHING
		.if eax && points>=4500
			;Moving pattern change
			push	eax
			invoke Random,256
			.if eax < 8
				pop		eax
				xor		eax,eax
				push	eax
			.endif
			pop		eax
		.endif
		.if !eax
			mov		xmax,1
		.else
			mov		eax,[esi].xmov
			add		[esi].x,eax
			mov		eax,[esi].ymov
			add		[esi].y,eax
			mov		eax,[esi].x
			add		eax,[esi].xmov
			.if eax > board_WIDTH - volcano_WIDTH - 1
				mov		xmax,eax
			.endif
		.endif
	.endif
	ASSUME	esi:NOTHING
	retn

DropVolcano:
	.if ndrop
		dec		cdrop
		.if !cdrop
			mov		cdrop,4
			mov		esi,offset volcanos
			ASSUME	esi:PTR VOLCANO
			xor		ecx,ecx
			.while ecx < MAX_VOLCANOS
				.if ![esi].state
					; center top
					mov		[esi].x,(board_WIDTH + volcano_WIDTH)/2
					mov		[esi].y,0
					mov		[esi].state,volcano_SPIN1a
					mov		[esi].xmov,0
					mov		[esi].ymov,volcano_HEIGHT
					mov		[esi].xmovs,-6
					dec		ndrop
					inc		nvolcanos
					.break
				.endif
				add		esi,SIZEOF VOLCANO
				inc		ecx
			.endw		
			ASSUME	esi:NOTHING
		.endif
	.endif
	retn

MoveShot:
	ASSUME	esi:PTR SHOT
	.if [esi].state
		mov		ebx,[esi].y
		invoke GetPixel,mDC,[esi].x,[esi].y
		.if eax==RGB(128,128,128) && points>=4500 && points<6000
			;Norwegian missils, lighting does no harm
			mov		eax,0
		.endif
		.if eax
			; Hit something (Yellow or Aqua)
			.if eax==RGB(255,255,0) || eax==RGB(0,255,255)
				; Hit fire ball
				mov		eax,[esi].x
				push	esi
				xor		ecx,ecx
				mov		esi,offset volcanos
				ASSUME	esi:PTR VOLCANO
				.while ecx < MAX_VOLCANOS
					push	ecx
					mov		ecx,[esi].x
					lea		edx,[ecx + volcano_WIDTH]
					.if eax>=ecx && eax<=edx
						mov		ecx,[esi].y
						lea		edx,[ecx + volcano_HEIGHT]
						.if ebx>=ecx && ebx<=edx
							.if [esi].state
								.if [esi].state==volcano_INACTIVE
									add		points,points_VOLCANOx
									mov		[esi].state,volcano_OFF
									dec		moreguns
									.if !moreguns
										mov		moreguns,100 ;!
										inc		nguns
									.endif
								.else
									add		points,points_VOLCANO
									mov		[esi].state,volcano_INACTIVE
									dec		nvolcanos
								.endif
								pop		ecx
								.break
							.endif
						.endif
					.endif
					pop		ecx
					add		esi,SIZEOF VOLCANO
					inc		ecx
				.endw
				pop		esi
				ASSUME	esi:PTR SHOT
			.elseif eax==RGB(255,255,255) ; white
			.else
			.endif
			mov		[esi].state,shot_NO
		.else
;			mov		ebx,[esi].y
			invoke SetPixel,mDC,[esi].x,ebx,color_BACKGROUND
			dec		ebx
			invoke SetPixel,mDC,[esi].x,ebx,color_BACKGROUND
			dec		ebx
			invoke SetPixel,mDC,[esi].x,ebx,color_BACKGROUND
			dec		ebx
			invoke SetPixel,mDC,[esi].x,ebx,color_SHOT
			dec		ebx
			invoke SetPixel,mDC,[esi].x,ebx,color_SHOT
			dec		ebx
			invoke SetPixel,mDC,[esi].x,ebx,color_SHOT
			sub		[esi].y,3
			.if [esi].y > board_HEIGHT
				; Outside boarder
				mov		[esi].state,shot_NO
			.endif
		.endif
	.endif
	add		esi,SIZEOF SHOT
	ASSUME	esi:NOTHING
	retn

PaintBoard endp

SetupGame proc uses ebx,hWin:DWORD

	mov		halt,TRUE
	mov		points,0
	mov		gunx,0
	mov		nguns,gun_INIT
	mov		gunshots,gun_SHOTS
	mov		goy,0
	mov		cvolcano,6 ; extra delay at start

	i = 0
	WHILE i NE MAX_SHOTS
		mov		shots[i].state,0
		i = i + 1
	ENDM

	mov		cdrop,4
	mov		ndrop,10
	mov		nvolcanos,0
	mov		moreguns,100

	mov cheat, 46189
	invoke RtlZeroMemory,offset volcanos,sizeof volcanos
	invoke InvalidateRect,hWin,NULL,TRUE
	ret

SetupGame endp

BoardProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	ps:PAINTSTRUCT

	.if uMsg==WM_PAINT
		invoke BeginPaint,hWin,addr ps
		invoke PaintBoard,hWin,ps.hdc
		invoke EndPaint,hWin,addr ps
		xor		eax,eax
		ret
	.endif
	invoke CallWindowProc,OldBoardProc,hWin,uMsg,wParam,lParam
	ret

BoardProc endp

TimerProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	x:DWORD
	LOCAL	y:DWORD

	.if !halt || goy
		invoke GetKeyState,VK_LEFT
		and		al,80h
		.if al && gunx
			sub		gunx, gun_MOVE
		.endif
		and		al,80h
		je		@F
		test	cheatx,al
		jne		@F
		mov		cheatx,al
		sub		cheat,1979339339
		@@:

		invoke GetKeyState,VK_RIGHT
		and		al,80h
		.if al && gunx < (board_WIDTH - gun_WIDTH)
			add		gunx, gun_MOVE
		.endif
		and		al,80h
		je		@F
		shr		al,1
		test	cheatx,al
		jne		@F
		mov		cheatx,al
		imul	eax,cheat,133319
		mov		cheat,eax
		@@:
		
		invoke GetKeyState,VK_DOWN
		and		al,80h
		je		@F
		shr		al,2
		test	cheatx,al
		jne		@F
		mov		cheatx,al
		imul	eax,cheat,173
		mov		cheat,eax
		@@:

		invoke GetKeyState,VK_UP
		and		al,80h
		je		@F
		shr		al,3
		test	cheatx,al
		jne		@F
		mov		cheatx,al
		add		cheat,9973
		@@:

		invoke InvalidateRect,hBoard,NULL,TRUE
	.else
		inc		rseed
	.endif
	ret

TimerProc endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	hBmp:DWORD
	LOCAL	rect:RECT

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		m2m		hWnd,hWin
	    invoke ImageList_Create,image_WIDTH,image_HEIGHT,ILC_COLOR4,image_IMAGES,image_IMAGES
	    mov     hIml,eax
	    invoke LoadBitmap,hInstance,IDB_VOLCANO
	    mov     hBmp,eax
	    invoke ImageList_Add,hIml,hBmp,NULL
	    invoke DeleteObject,hBmp
		invoke GetDlgItem,hWin,IDC_BOARD
		mov		hBoard,eax
		invoke SetWindowLong,hBoard,GWL_WNDPROC,offset BoardProc
		mov		OldBoardProc,eax
		invoke SetupGame,hBoard
		mov		lptext,offset szIntro
		mov		goy,1300 ;!
		invoke SetTimer,hWin,timer_ID,timer_INTERVAL,offset TimerProc
	.elseif eax==WM_SIZE
		invoke GetClientRect,hWin,addr rect
		invoke MoveWindow,hBoard,0,0,rect.right,rect.bottom,TRUE
	.elseif eax==WM_KEYDOWN
		mov		eax,wParam
		.if eax==VK_SPACE
			cmp		cheat,293B4F57h
			jne		@F
			add		points,points_MORESHOTS
			@@:
			mov		edx,offset shots
			ASSUME	edx:PTR SHOT
			mov		ecx,MIN_SHOTS
			.if points >= points_MORESHOTS
				mov		ecx,MAX_SHOTS
			.endif
			.while ecx > 0
				.if ![edx].state
					mov		cheatx,0
					; Fire a missile
					mov		eax,gunx
					add		eax,(1 + gun_WIDTH) / 2
					mov		[edx].x,eax
					mov		[edx].y,board_HEIGHT - gun_HEIGHT
					mov		[edx].state,shot_FIRE
					dec		gunshots
					.if !gunshots
						dec		nguns
						mov		gunshots,gun_SHOTS
					.endif
					.break
				.endif
				add		edx,SIZEOF SHOT
				dec		ecx
			.endw
			ASSUME	edx:NOTHING
		.endif
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDM_FILE_EXIT
			invoke SendMessage,hWin,WM_CLOSE,0,0
		.elseif eax==IDM_NEW_GAME
			invoke SetupGame,hBoard
			mov		halt,FALSE
		.elseif eax==IDM_HELP_ABOUT
			invoke ShellAbout,hWin,addr AppName,addr AboutMsg,NULL
		.endif
	.elseif eax==WM_CLOSE
		invoke KillTimer,hWin,timer_ID
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke ImageList_Destroy,hIml
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

end start
