include windows.inc
include user32.inc
include kernel32.inc
include shell32.inc
include comctl32.inc
include gdi32.inc

includelib user32.lib
includelib kernel32.lib
includelib shell32.lib
includelib comctl32.lib
includelib gdi32.lib

WinMain				PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndProc				PROTO :DWORD,:DWORD,:DWORD,:DWORD


m2m MACRO m1:REQ, m2:REQ
	push m2
	pop  m1
ENDM

RGB MACRO red:REQ, green:REQ, blue:REQ
	EXITM %(red + 256 * (green + (256 * blue)))
ENDM


.const

IDB_VOLCANO			equ 100
IDR_ACCEL			equ 150

IDD_VOLCANO			equ 1000
IDC_BOARD			equ 1001

IDR_MENU			equ 10000
IDM_FILE_EXIT		equ 10001
IDM_NEW_GAME		equ 10002
IDM_HELP_ABOUT		equ 10101

; --- Game Parameters
MIN_SHOTS			equ 3
MAX_SHOTS			equ 5
MAX_VOLCANOS		equ 64

board_WIDTH			equ 256
board_HEIGHT		equ 256

image_IMAGES		equ 6
image_WIDTH			equ 12
image_HEIGHT		equ 12
image_GUN			equ 0
image_VOLCANO1a		equ 1
image_VOLCANO1b		equ 2
image_VOLCANO2a		equ 3
image_VOLCANO2b		equ 4
image_VOLCANOx		equ 5

color_BACKGROUND	equ RGB(0,0,0)
color_SHOT			equ RGB(255,255,255)
color_SCORE			equ RGB(255,255,255)

gun_HEIGHT			equ image_HEIGHT
gun_WIDTH			equ image_WIDTH
gun_MOVE			equ 4
gun_SHOTS			equ 750
gun_INIT			equ 3

volcano_HEIGHT		equ image_HEIGHT
volcano_WIDTH		equ image_WIDTH

	; Volcano States
volcano_OFF			equ 0
volcano_SPIN1a		equ image_VOLCANO1a
volcano_SPIN1b		equ image_VOLCANO1b
volcano_SPIN2a		equ image_VOLCANO2a
volcano_SPIN2b		equ image_VOLCANO2b
volcano_INACTIVE	equ image_VOLCANOx
	; Shot States
shot_NO				equ 0
shot_FIRE			equ 1

points_VOLCANO		equ 10
points_VOLCANOx		equ 5
points_LIGHTNING	equ 3000
points_MORESHOTS	equ 6000

lightning_MAX		equ 4
lightning_ODDS		equ 64 ; Odds of lightning occurance

timer_ID			equ 200
timer_INTERVAL		equ 50
volcano_SPEED		equ 2
volcano_ANIMATE		equ 4


.data

volcano_FSM dd volcano_OFF,
	volcano_SPIN1b,
	volcano_SPIN1a,
	volcano_SPIN2b,
	volcano_SPIN2a,
	volcano_INACTIVE

ClassName			db 'DLGCLASS',0
AppName				db 'Volcano',0
AboutMsg			db 'RadASM Volcano',13,10,'Copyright  KetilO 2002',0
szIntro				db 'A volcano has exploded and are',0
					db 'sending balls of fire up in the',0
					db 'air, threthening to destroy the',0
					db 'capitol of the kingdom Bermundo.',0
					db 'As the commander of Bermundos',0
					db 'airforce the King has given',0
					db 'you the glorious mission to',0
					db 'save the citisens from disaster.',0
					db ' ',0
					db ' ',0
					db 'Commanders log:',0
					db 'I must not fail the Kings trust',0
					db 'in me. I will save the city.',0
					db ' ',0
					db 'Commanders log:',0
					db 'I must have hit more than 100 of',0
					db 'those bastards. Luckily the',0
					db 'Russians provided me with a',0
					db 'cannon and missils.',0
					db ' ',0
					db 'Commanders log:',0
					db "At least a 200. Damn, it's",0
					db 'lightning and thunder and damn',0
					db 'Russian missils, exploding in',0
					db 'thin air when lightning.',0
					db ' ',0
					db 'Commanders log:',0
					db 'There must be 300 now. Got',0
					db 'hold of some high quality',0
					db 'Norwegian missils, but there',0
					db 'is evil. They changed their',0
					db 'moving pattern. Unless I can',0
					db 'get hold of some American',0
					db 'target seeking missils ...',0
					db ' ',0
					db 'Commanders log:',0
					db '400. Damn Americans and their',0
					db 'policy. They would not provide',0
					db 'me with missils, and whats worse,',0
					db 'they denied Norway to deliver.',0
					db 'Back to Russian missils. At least',0
					db 'I got hold of a cannon cooler.',0
					db ' ',0
					db 'Commanders log:',0
					db 'More than 500. Oh my God, they',0
					db 'are incresing in number ...',0
					db ' ',0
					db ' ',0
					db ' ',0
					db 'KetilO  2002',0,0
szGameOver			db 'Game Over.',0,0

fmtStr				db '%lu',0


.data?

SHOT STRUCT
	x dd ?
	y dd ?
	state dd ?
SHOT ENDS

VOLCANO STRUCT
	x dd ?
	y dd ?
	state dd ?
	xmov dd ?
	ymov dd ?
	xmovs dd ?
VOLCANO ENDS


hInstance			dd ?
CommandLine			dd ?
hWnd				dd ?
hAccel				dd ?

hBoard				dd ?
OldBoardProc		dd ?
hIml				dd ?

rseed				dd ?
loopcount			dd ?
lptext				dd ?
goy					dd ?
halt				dd ?
clightning			dd ?
points				dd ?
gunshots			dd ?
nguns				dd ?
gunx				dd ?
shots		SHOT MAX_SHOTS dup ({})
cvolcano			dd ?
cdrop				dd ?
ndrop				dd ?
nvolcanos			dd ?
volcanos	VOLCANO MAX_VOLCANOS dup ({})
moreguns			dd ?

cheat				dd ?
cheatx				db ?
